#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct LiteralRange {
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "startTimestamp", skip_serializing_if = "Option::is_none", default)]
    start_timestamp: Option<Box<super::super::super::super::super::api::Timestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "endTimestamp", skip_serializing_if = "Option::is_none", default)]
    end_timestamp: Option<Box<super::super::super::super::super::api::Timestamp>>,
    #[builder(default, into)]
    #[serde(rename = "tags", skip_serializing_if = "Option::is_none", default)]
    tags: Option<std::collections::BTreeMap<String, String>>,
}
impl LiteralRange {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn start_timestamp(
        &self,
    ) -> Option<&super::super::super::super::super::api::Timestamp> {
        self.start_timestamp.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn end_timestamp(
        &self,
    ) -> Option<&super::super::super::super::super::api::Timestamp> {
        self.end_timestamp.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn tags(&self) -> Option<&std::collections::BTreeMap<String, String>> {
        self.tags.as_ref().map(|o| &*o)
    }
}
